/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ListModelController");

dojo.require("com.ibm.mashups.enabler.ListModel");

/**
 * A modifiable model representing a list. Acting as a base class for all concrete list models.
 * @ibm-api
 * @ibm-module Base
*/
dojo.declare("com.ibm.mashups.enabler.ListModelController", com.ibm.mashups.enabler.ListModel, {
    /**
     * Creates a new model object. The created node can be inserted
     * into the model using an appropriate <code>insert</code> method defined
     * on a subinterface of this interface. The node will not appear in the model
     * unless it is inserted.
     * @param {JSON} context array of predefined information
     * used for the creation of the node. May be <code>null</code>. Accepted
     * names are defined in the appropriate subinterfaces
     * @type Object
     * @return the created node
     */
    create: function(context){
    },
    /**
     * Confirms whether creating the node is possible.
     * @param {JSON} context array of predefined information
     * used for the creation of the node. May be <code>null</code>. Accepted
     * names are defined in the appropriate subinterfaces
     * @return {Boolean} true if the node can be created, otherwise false.
     */
    confirmCreate: function(context){
    },
    
    /**
     * Inserts the specified node into the list model at the specified
     * position; the node must be created with the create method of the
     * concrete ListModel
     *
     * @param {Object} node     node or node uri (without any scope) to
     *                          insert into the list model. Must not be
     *                          <code>null</code>
     * @param {Object} nextNode node object or node uri (without any scope) of
     *                          the successor node before which the node
     *                          is to be inserted;
     *                          if <code>null</code> is specified, the
     *                          node is appended at the end of the existing nodes
     * @type void
     */
    insert: function(node, nextNode){
    },
    
    /**
     * Confirms whether inserting the node is possible.
     * @param {Object} node     node or node uri (without any scope) to
     *                          insert into the list model. Must not be
     *                          <code>null</code>
     * @param {Object} nextNode node object or node uri (without any scope) of
     *                          the successor node before which the node
     *                          is to be inserted;
     *                          if <code>null</code> is specified, the
     *                          node is appended at the end of the existing nodes
     * @return {Boolean} true if the node can be inserted, otherwise false.
     */
    confirmInsert: function(node, nextNode){
    },
    
    /**
     * Removes the specified node from the list model
     *
     * @param{Object} node  node object or node uri (without any scope).
     *                      Must not be <code>null</code>
     * @type void
     */
    remove: function(node){
    },
    
    /**
     * Confirms whether removing the node is possible.
     * @param{Object} node  node object or node uri (without any scope).
     *                      Must not be <code>null</code>
     * @return {Boolean} true if the node can be removed, otherwise false.
     */
    confirmRemove: function(node){
    }
});
