/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ResourceLocator");

dojo.require("com.ibm.mashups.enabler.Locator");

/**
 * Interface for finding resources within a model.
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.ResourceLocator", com.ibm.mashups.enabler.Locator, {

    /**
     * Returns the URL of the resource to be located, or <code>null</code> if the resource cannot be found.
     * @param {Object} node A node of the model this locator is implemented on. Must not be <code>null</code>.
     * @param {String} name The name of the resource to be located within the given model. The name can also contain a directory path relative to the model. Must not be <code>null</code>.
     * @return {String} The URL that can be used to fetch the resource, or <code>null</code> if the resource cannot be found.
     * @deprecated Use findResourceURL instead.
     */
    findResourceUrl: function(node, name){
    },
    
    /**
     * Returns the URL of the resource to be located, or <code>null</code> if the resource cannot be found.
     * @param {Object} node A node of the model this locator is implemented on. Must not be <code>null</code>.
     * @param {String} name The name of the resource to be located within the given model. The name can also contain a directory path relative to the model. Must not be <code>null</code>.
     * @return {String} The URL that can be used to fetch the resource, or <code>null</code> if the resource cannot be found.
     */
    findResourceURL: function(node, name){
    }    
});
