/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.Transformable");

//<INTERFACE>
/**
 * Interface for resources in the system that can be transformed
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.Transformable", null, {
    /**
     * Returns the xml representation of the resource. It may be modified,
     * e.g. with an xsl transformation.
     * WARNING: Please note that you must change the xml representation
     * of the resource in a compatible way only, since the Enabler API
     * operates on this representation. Otherwise the Enabler API may
     * function incorrectly or break.
     * @return {Object} the xml representation; never <code>null</code>
     */
    getXml: function() {
    },
    
    /**
     * Sets the specified xml of the resource.
     * WARNING: Please note that you must set a valid xml representation
     * of the resource, since the Enabler API operates on this representation.
     * Otherwise the Enabler API may function incorrectly or break.
     * @param {Object} xml the xml representation to set for the resource
     */
    setXml: function(xml) {
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.TransformableImpl");
