/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.TreeModel");

dojo.require("com.ibm.mashups.enabler.model.Model");
dojo.require("com.ibm.mashups.enabler.Locator");

/**
 * This interface provides a generic tree model acting as a base class
 * for all concrete tree models
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.TreeModel", [com.ibm.mashups.enabler.model.Model, com.ibm.mashups.enabler.Locator], {
    /**
     * Returns the root node of the model; may return <code>null</code>
     * if the concrete tree model supports for empty models
     *
     * @type    Deferred
     * @return  a deferred object used to start this operation. The
     *          return value when executed through the deferred object
     *          is the root object of the tree model
     */
    getRoot: function(){
    },
    
    /**
     * Returns whether or not the given node has children. Please pay
     * attention to the documentation of the return value; it is not
     * guaranteed that children are present if the method returns
     * <code>true</code> - the iterator might be empty.
     *
     * @param   {Object} node   node object or node uri (without any scope)
     *                          for which to check if it has children. Must
     *                          not be <code>null</code>.
     * @return {Boolean} <tt>true</tt> if the specified node has children, <tt>false</tt> otherwise
     */
    hasChildren: function(node){
    },
    
    /**
     * Returns an iterator over the child elements for the given node.
     *
     * @param {Object} node node object or node uri (without any scope)
     *                      for which to return its children. Must not
     *                      be <code>null</code>.
     * @return {com.ibm.mashups.enabler.DeferredIterator} deferred iterator for the children of the given node.
     *          Never <code>null</code>
     */
    getChildren: function(node){
    },
    
    /**
     * Returns the parent of a given node.
     * @param {Object} node node object or node uri (without any scope)
     *                      for which to return its parent. Must not
     *                      be <code>null</code>.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. The
     *          return value when executed through the deferred object
     *          is the parent of the given node, or <code>null</code>
     *          if the node has no parent
     */
    getParent: function(node){
    }
});
