/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ac.AccessControlModel");

dojo.require("com.ibm.mashups.enabler.Deferred");
dojo.require("com.ibm.mashups.enabler.model.Model");
dojo.require("com.ibm.mashups.enabler.user.User");
dojo.require("com.ibm.mashups.enabler.ac.RoleModel");
//<INTERFACE>
/**
 * Interface for a access control model.
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.AccessControlModel", [com.ibm.mashups.enabler.model.Model], {

    /**
     * Indicates if the model is initialized.for the underlying resource.
     * @ibm-spi
     * @return {Boolean} <code>true</code> if the model is initialized, <code>false</code> otherwise
     */
    isInitialized: function() {
    },
    
    /**
     * Returns the owner of the resource
     * @type com.ibm.mashups.enabler.user.User
     * @return the owner of the resource; never <code>null</code>.
     */
    getOwner: function() {
    },
    /**
     * Sets a new owner for the resource
     * @type void
     * @param {com.ibm.mashups.enabler.user.User} user the new owner for the resource. Must not be <code>null</code>.
     */
    setOwner: function(user) {
    },
    
    /**
     * Confirms whether setting a new owner is possible.
     * @param {com.ibm.mashups.enabler.user.User} user new owner to set; must not be <code>null</code>
     * @return {Boolean} <code>true</code> if the new owner can be set, <code>false</code> otherwise.
     */
    confirmSetOwner: function(user) {
    },
    
    /**
     * Same as getRoleModel(true).
     * @type RoleModel
     * @return a RoleModel object. Never <code>null</code>.
     */
    getRoleModel: function() {
    },
    /**
     * Returns the role model for the given access control model.
     * @type RoleModel
     * @param {Boolean} create defines whether the role model should be created if it is not available
     * @return a RoleModel object. May be <code>null</code> if called with create equals false.
     */
    getRoleModel: function(create) { // JSLINT-IGNORE: cannot change public API
    },
    
    /**
     * Confirms whether getting the role model is possible
     * @return {Boolean} <code>true</code> if retrieving the role model is possible, <code>false</code> otherwise
     */
    confirmGetRoleModel: function() {
    },
    
    /**
     * Commits the modifications applied to this model and all dependent models.<br>
     * @return {DeferredOperation} a deferred object used to start this operation.
     * The return value when executed through the deferred object is <code>null</null>
     */
    commit: function() {
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.ac.AccessControlModelImpl");
