/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ac.RoleModel");

dojo.require("com.ibm.mashups.enabler.ListModelController");
dojo.require("com.ibm.mashups.enabler.ac.RoleNode");
dojo.require("com.ibm.mashups.enabler.ac.MemberModel");
//<INTERFACE>
/**
 * Interface for an access control role model
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.RoleModel", [com.ibm.mashups.enabler.ListModelController], {

    /**
     * Creates a new Role. The created role can be inserted into the model
     * using an appropriate <code>insert</code> method. The node will not appear
     * in the model unless it is inserted.
     * @param {JSON} context json object of predefined name/value pairs
     * used for the creation of the node. Never <code>null</code>. Accepted names are:<br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>roletype</code> - value: one of the role type constants
     * (mandatory)<br>
     * @return {RoleNode} created role node. Returns <code>null</code> if a Role already exists
     * for the specified role type.
     */
    create: function(context){
    },
    
    /**
     * Returns the member model for the given role.
     * @param {RoleNode} roleNode the role to retrieve the member model for
     * @type MemberModel
     */
    getMemberModel: function(roleNode){
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.ac.RoleModelImpl");
