/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ac.operation.Constants");

/**
 * com.ibm.mashups.enabler.ac.operation.Constants defines all the public 
 * menu operation constants.<br/>
 * Each constants should be referred to as : 
 * com.ibm.mashups.enabler.ac.operation.Constants.EDIT_PAGE_LAYOUT...
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.operation.Constants", null, {

    /**
     * Edit page layout operation enabling the user to edit and change
     * the layout of a given page. <BR>
     * The <code>com.ibm.mashups.enabler.ac.operation.Operation.isAllowed()</code>
     * call require a JSON context with:<BR>
     * &nbsp; &nbsp; contentNode: the ID of the page for which to perform the check
     * @type String
     */ 
    EDIT_PAGE_LAYOUT: "com.ibm.mashups.enabler.ac.operation.editpagelayout",

    /**
     * Edit page properties operation enabling the user to edit and change
     * the properties of a given page. <BR>
     * The <code>com.ibm.mashups.enabler.ac.operation.Operation.isAllowed()</code>
     * call require a JSON context with:<BR>
     * &nbsp; &nbsp; contentNode: the ID of the page for which to perform the check
     * @type String
     */     
    EDIT_PAGE_PROPERTIES: "com.ibm.mashups.enabler.ac.operation.editpageproperties",
    
    /**
     * Assign page permission operation enabling the user to edit and change
     * the permissions and owner of a given page. <BR>
     * The <code>com.ibm.mashups.enabler.ac.operation.Operation.isAllowed()</code>
     * call require a JSON context with:<BR>
     * &nbsp; &nbsp; contentNode: the ID of the page for which to perform the check
     * @type String
     */ 
    ASSIGN_PAGE_PERMISSIONS: "com.ibm.mashups.enabler.ac.operation.assignpagepermissions"
});

com.ibm.mashups.enabler.ac.operation.Constants = new com.ibm.mashups.enabler.ac.operation.Constants();
