/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ac.operation.Operation");

dojo.require("com.ibm.mashups.enabler.ac.operation.Constants");

//<INTERFACE>
/**
 * Interface for checking if a operation is allowed to execute
 * by the current user.<BR>
 * Operations are more coarse grained actions compared to the 
 * confirmable APIs.
 *
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.operation.Operation", null, {
    /**
     * Checks if the operation is allowed to be executed by
     * the current user.
     * 
     * @type Boolean
     * @return <code>true</code> if the operation is allowed to be
     *         executed by the current user, <code>false</code> otherwise.
     *         Can never be <code>null</code>.
     */
    isAllowed: function(){
    }
});
//</INTERFACE>
