/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.content.RuntimeContent");

dojo.require( "com.ibm.mashups.enabler.Deferred");
//<INTERFACE>
/**
 * This interface exposes the markup of the runtime content provider, i.e. the
 * full markup including all model artifacts like widgets, wires, etc.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module CoreModel
*/
dojo.declare("com.ibm.mashups.enabler.content.RuntimeContent", null, {

    /**
     * Returns the markup of this runtime content provider. The runtime markup
     * represents the current markup, including any modifications applied to
     * this runtine content provider.
     *
     * @return {com.ibm.mashups.enabler.Deferred} A deferred object used to start this operation,
     * never <code>null</code>. The return value when executed through the
     * deferred object is the runtime markup as String.
     */
    getRuntimeMarkup: function(){
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.RuntimeContent.getRuntimeMarkup');
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.content.RuntimeContentImpl");
