/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.content.ServerRuntimeContent");

dojo.require("com.ibm.mashups.enabler.model.state.NavigationStateModel");
dojo.require("com.ibm.mashups.enabler.Deferred");

/**
 * This interface exposes the markup of the server runtime content provider, i.e. the
 * full markup including all model artifacts like widgets, wires, etc. plus personalization
 * rules applied. The markup is based on the navigation state represented by a navigation
 * state model.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.content.ServerRuntimeContent", null, {

    /**
     * Returns the server runtime markup of this provider. The server runtime markup
     * is based on the provided navigation state.
     *
     * @param {com.ibm.mashups.enabler.model.state.NavigationStateModel} navigationState navigation 
     * state model representing the navigation state, or <code>null</code> to use the 
     * current navigation state model
     * @return {com.ibm.mashups.enabler.Deferred} A deferred object used to start this operation,
     * never <code>null</code>. The return value when executed through the
     * deferred object is the runtime markup as String.
     */
    getServerRuntimeMarkup: function(navigationState){
        throw new Error('Unimplemented API: com.ibm.mashups.enabler.content.ServerRuntimeContent.getServerRuntimeMarkup');
    }
});
