/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.layouttemplate.LayoutTemplate");
dojo.require("com.ibm.mashups.enabler.ListModelController");
dojo.require("com.ibm.mashups.enabler.ResourceLocator");
dojo.require("com.ibm.mashups.enabler.Commitable");

/**
 * This list model controller exposes layout templates. It allows to add and
 * remove layout templates.
 * 
 * @since 2.4
 * 
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.layouttemplate.LayoutTemplateModel", [
		com.ibm.mashups.enabler.ListModelController,
		com.ibm.mashups.enabler.ResourceLocator,
		com.ibm.mashups.enabler.Commitable ], {
	/**
	 * Creates a layout template. Note that it will not appear in the model unless
	 * it is inserted using the <code>insert</code> method.
	 *
	 * @param {JSON} context array of predefined information used for the creation of
	 * the layout template. Must not be <code>null</code>. You must specify all of following:<br>
	 * &nbsp;&nbsp;<b><code>name</code></b> - name as string; mandatory <br>
	 * @return {com.ibm.mashups.enabler.layouttemplate.LayoutTemplate} the created layout template, or <code>null</code> in case
	 * it cannot be created.
	 */
	create : function(context) {
	}
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.layouttemplate.LayoutTemplateModel");
