/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.SpaceModel");

dojo.require("com.ibm.mashups.enabler.ListModelController");
dojo.require("com.ibm.mashups.enabler.Deferred");
dojo.require("com.ibm.mashups.enabler.SubmittableFormProvider");
dojo.require("com.ibm.mashups.enabler.space.SpaceLocator");
dojo.require("com.ibm.mashups.enabler.space.SpaceNode");
//<INTERFACE>
/**
 * Interface for a space model.<br>
 * <br>
 * The space model supports the following strategies:
 * <ul>
 * <li>{@link com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy ListLoadAheadStrategy}</li>
 * <li>{@link com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy HiddenMetaDataLoadingStrategy}</li>
 * </ul>
 * 
 * @ibm-api
 * @ibm-module SpaceModel
 */
dojo.declare("com.ibm.mashups.enabler.model.SpaceModel", [
		com.ibm.mashups.enabler.ListModelController,
		com.ibm.mashups.enabler.SubmittableFormProvider,
		com.ibm.mashups.enabler.space.SpaceLocator ], {
	/**
	 * creates a new Space node. The created node can be inserted into the model
	 * using an appropriate <code>insert</code> method. The node will not appear
	 * in the model unless it is inserted.
	 * @param {JSON} context array of predefined information
	 * used for the creation of the node. Should be <code>null</code>.
	 * @type com.ibm.mashups.enabler.space.SpaceNode
	 * @return created space node
	 */
	create : function(context) {
	},

    /**
    * Commits the modifications applied to this model and all dependant models<br>
    * @return {DeferredOperation} a deferred object used to start this operation. 
    * The return value when executed through the deferred object is <code>null</null>
    */
	commit : function() {
	},

	/**
	 * Confirms whether exporting the node is possible.
	 * @param{com.ibm.mashups.enabler.space.SpaceNode} space space or space uri (without any scope).
	 *                      Must not be <code>null</code>
	 * @return {Boolean} true if the node can be exported, otherwise false.
	 */
	confirmExport : function(space) {
	},

	/**
	 * Confirms whether copying the node is possible.
	 * @param{com.ibm.mashups.enabler.space.SpaceNode} space space or space uri (without any scope).
	 *                      Must not be <code>null</code>
	 * @return {Boolean} true if the node can be copied, otherwise false.
	 */
	confirmCopy : function(space) {
	},

	/**
	 * Returns a SubmittableForm object associated with the given id to import a space.
	 * Same as <code>getSubmittableForm</code>
	 * @param {String} id the id of the html form this object is associated with
	 * @return {com.ibm.mashups.enabler.SubmittableForm} SubmittableForm object, maybe <code>null</code>
	 */
	getSubmittableImportForm : function(id) {
	}
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.model.SpaceModelImpl");
