/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.state.AccessorFactory");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.model.state.PageAccessor");
dojo.require("com.ibm.mashups.enabler.model.state.SpaceAccessor");
dojo.require("com.ibm.mashups.enabler.model.state.WidgetAccessor");
dojo.require("com.ibm.mashups.enabler.model.state.PageModeAccessor");
dojo.require("com.ibm.mashups.enabler.model.state.ShareableParameterSetAccessor");
/**
 * Interface representing an AccessorFactory. Accessor API should be used to read/write information from NavigationStateModel.
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare( "com.ibm.mashups.enabler.model.state.AccessorFactory", null, {
    /**
     * Returns the Accessor to access Page selection in each Space
     * @param {com.ibm.mashups.enabler.model.state.NavigationStateModel} navStateModel NavigationStateModel to get Space/Page Selection
     * @param {String} spaceId spaceId to getPage Selection    
     * @type com.ibm.mashups.enabler.model.state.PageAccessor
     * @return {com.ibm.mashups.enabler.model.state.PageAccessor} The PageAccessor of NavigationStateModel
     */
	getPageAccessor:function(navStateModel,spaceId) {
        // look for node in model and instatiate the Page Accessor with Node
	},
	 /**
     * Returns the Accessor to access Space selection
     * @param {com.ibm.mashups.enabler.model.state.NavigationStateModel} navStateModel NavigationStateModel to get Space Selection
     * @type com.ibm.mashups.enabler.model.state.SpaceAccessor
     * @return {com.ibm.mashups.enabler.model.state.SpaceAccessor} The SpaceAccessor of NavigationStateModel
     */
	getSpaceAccessor:function(navStateModel) {
	},
	/**
     * Returns the Widget Accessor to access Widget state information
     * @param {com.ibm.mashups.enabler.model.state.NavigationStateModel} navStateModel to Widget Navigation State
     * @param {String} widgetId to Widget Navigation State
      * @type com.ibm.mashups.enabler.model.state.WidgetAccessor
     * @return {com.ibm.mashups.enabler.model.state.WidgetAccessor} The WidgetAccessor of NavigationStateModel
     */
	getWidgetAccessor:function(navStateModel, widgetId) {
	},
   /**
     * Returns the Accessor to access Page mode of current page
     * @param {com.ibm.mashups.enabler.model.state.NavigationStateModel} navStateModel NavigationStateModel to get Space/Page Selection
     * @type com.ibm.mashups.enabler.model.state.PageModeAccessor
     * @return {com.ibm.mashups.enabler.model.state.PageModeAccessor} The PageModeAccessor of NavigationStateModel
     */
	getPageModeAccessor:function(navStateModel) {
        // look for node in model and instatiate the Page Accessor with Node
	},
 /**
     * Returns the Accessor to access the sharable parameters
     * @param {com.ibm.mashups.enabler.model.state.NavigationStateModel} navStateModel NavigationStateModel to get ShareableParameterSet
     * @param {String}  id  id of ShareableParameterSet
     * @param {String}  scope  optional scope for the sharable item set. If not provided or null, the global scope is returned.
     * @type com.ibm.mashups.enabler.model.state.ShareableParameterSetAccessor
     * @return {com.ibm.mashups.enabler.model.state.ShareableParameterSetAccessor} The ShareableParameterSetAccessor of NavigationStateModel
     */
	getShareableParameterSetAccessor:function(navStateModel,id,scope) {
        // look for node in model and instatiate the Page Accessor with Node
	}  
	

});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.model.state.AccessorFactoryImpl");
