/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.state.PageModeAccessor");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.model.state.Accessor");
/**
 * Interface representing an PageModeAccessor.
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare( "com.ibm.mashups.enabler.model.state.PageModeAccessor", [com.ibm.mashups.enabler.model.state.Accessor] , {
  
	/**
    * VIEW mode of page, can be used as com.ibm.mashups.enabler.model.state.PageModeAccessor.VIEW with "view" as the actual value</br>
    * @type String
    */
  	VIEW:"view",
  
  	/**
    * EDIT mode of page, can be used as com.ibm.mashups.enabler.model.state.PageModeAccessor.EDIT with "edit" as the actual value</br>
    * @type String
    */
	EDIT:"edit",

	/**
     * Returns the of the page mode of current page.
     * @type String
     * @return {String} The page mode of current page
     */
	getPageMode:function() {
	},
	
	/**
     * Sets the page mode of the page
     * @param {String} pageMode The mode of the page
     * @type void
     */
	setPageMode:function(pageMode) {
	},
	 /**
     * Confirms if it's possible to set a new page mode
     * @param {String} pageMode The mode of the page
     * @type Boolean
     * @return{Boolean} return true if it's possible to set a new page mode
     */
	confirmSetPageMode:function(pageMode) {
		return true;
	}
});

com.ibm.mashups.enabler.model.state.PageModeAccessor.VIEW = "view";
com.ibm.mashups.enabler.model.state.PageModeAccessor.EDIT = "edit";
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.model.state.PageModeAccessorImpl");

