/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.navigation.NavigationElement");

dojo.require("com.ibm.mashups.enabler.Identifiable");
dojo.require("com.ibm.mashups.enabler.ModifiableMetaData");
dojo.require("com.ibm.mashups.enabler.ModifiableLocalized");
dojo.require("com.ibm.mashups.enabler.ThemeProvider");
dojo.require("com.ibm.mashups.enabler.Transformable");
dojo.require("com.ibm.mashups.enabler.ac.EffectiveAccess");
//<INTERFACE>
/**
 * Base interface for navigation elements
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.navigation.NavigationElement", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.ModifiableMetaData, com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mashups.enabler.ThemeProvider, com.ibm.mashups.enabler.ac.EffectiveAccess, com.ibm.mashups.enabler.Transformable], {
    /**
     * Returns whether this navigation element is flagged as hidden. It is the responsibility of the
     * UI to render the navigation correctly and honor this flag.
     * @return {Boolean} <code>true</code> if the navigation is flagged as hidden, otherwise <code>false</code>.
     */
    isHidden: function() {
    },
    
    /**
     * Allows to flag the navigation element as hidden or visible.
     * @param {Boolean} hide <code>true</code> to hide the navigation, otherwise <code>false</code>.
     * @return {void}
     */
    setHidden: function(hide) {
    },
    
    /**
     * Confirms whether setting the hidden flag is possible.
     * @param {Boolean} hide <code>true</code> to hide the space, otherwise <code>false</code>.
     * @return {Boolean} <code>true</code> if the value can be set, otherwise <code>false</code>.
     */
    confirmSetHidden: function(hide) {
    },
    
    /**
     * Returns the type of this navigation element as defined in {@link com.ibm.mashups.enabler.navigation.Constants Constants}.
     * @return {String} type of this navigation element
     */
    getNavigationElementType: function() {
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.navigation.NavigationElementImpl");
