/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.runtime.skin.RuntimeSkinNode");
dojo.require("com.ibm.mashups.enabler.runtime.skin.Constants");

/**
 * Interface representing a runtime skin node
 * @ibm-api
 * @ibm-module CoreModel
 * @since 2.4
 */
dojo.declare( "com.ibm.mashups.enabler.runtime.skin.RuntimeSkinNode", com.ibm.mashups.enabler.Identifiable,     {
   /**
    * @private
    */
    constructor:function () {
    },
    
    /**
     * Returns the style attributes of the layout node represented by this runtime skin node
     * @return {JSON} style style attributes as a JSON object. Must not be <code>null</code>.  For example:<br>
     * <code>&#123; <br>
     * &nbsp;&nbsp;position: "absolute",<br>
     * &nbsp;&nbsp;left: "18px", <br>
     * &nbsp;&nbsp;width: "400px", <br>
     * &nbsp;&nbsp;height: "325px", <br>
     * &nbsp;&nbsp;z-index "51", <br>
     * &#125; </code><br>
     */
    getStyle: function() {
    },
	
	/**
	 * Returns the value of a client side dynamic content.  See &nbsp; {@link com.ibm.mashups.enabler.runtime.skin.Constants Constants} for dynamic content name constants
	 * @param {String} name name of the client side dynamic content spot to return. May not be <code>null</code>
	 * @return {String} value of the client side dynamic content spot, <code>null</code> if it does not exist
	 * @see com.ibm.mashups.enabler.runtime.skin.Constants
	 */
	getDynamicContent: function(name) {
	},
	
	/**
	 * Returns the layout node represented by this runtime skin node
	 * @return {com.ibm.mashups.enabler.layout.LayoutNode} the layout node which contains this runtime skin.  Will not be <code>null</code>
	 */
	getLayoutNode: function() {
	},
	
	/**
	 * Returns the HTML DOM Element for the specified client side dynamic content. See &nbsp; {@link com.ibm.mashups.enabler.runtime.skin.Constants Constants} for dynamic content name constants
	 * @param {String} name name of the client side dynamic content spot to return. May not be <code>null</code>
	 * @return {Object} HTML DOM Element for the client side dynamic content, <code>null</code> if it does not exist
	 */
	getDomElementForDynamicContent: function(name) {
	}
});

