/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.services.ConfigService");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.services.ConfigObject");

/**
 * The Config Service allows to access config variables as defined by the system.
 * The service can be retrieved using the following code: <br>
 * <code>var configService = com.ibm.mashups.services.ServiceManager.getService(<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);</code><br/>
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.services.ConfigService", null, {
    /**
     * The service name to be used to fetch the service from the ServiceManager
     * @type String
     */
    SERVICE_NAME: "configService",
    
    /**
     * This method returns the value of the config variable as defined by the system
     * @param {String} name the name of the config variable
     * @return {String} the value of the config variable. Maybe be NULL.
     */
    getValue: function(name) {
        return null;
    },
    
    /**
     * This method returns the value of the config object for a config provider
     * @param {String} name the name of the config provider
     * @return {com.ibm.mashups.enabler.services.ConfigObject} the config provider. Maybe be NULL.
     */
    getConfigObject: function(name) {
        return null;
    },
    
    /**
     * This method returns the Config Provider names.  Each Config Provider will
     * have a corresponding ConfigObject.
     * @return {String[]} the config provider names. Never NULL.
     */
    getConfigProviderNames: function() {
        return null;
    }
});
// make sure we can reference this globally
com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME = "configService";
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.services.ConfigServiceDefaultImpl");
