/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.space.SpaceExtensionLocator");

dojo.require("com.ibm.mashups.enabler.Locator");
dojo.require("com.ibm.mashups.enabler.model.space.SpaceExtension");

/**
 * This locator interface allows searching on the space extension model
 * @ibm-api
 * @ibm-module SpaceModel
 */
dojo.declare("com.ibm.mashups.enabler.space.SpaceExtensionLocator", [com.ibm.mashups.enabler.Locator],     {
    /**
     * Returns the corresponding space extension for the given space node, or null if none exists
     * @param {com.ibm.mashups.enabler.space.SpaceNode} spaceNode the SpaceNode object to find the extension for. Must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is
     * a space extension for the given space node or <code>null</code> if there no appropriate space extension available.
     * @see SpaceExtension
     */
    findExtensionBySpace: function (spaceNode) {
    }	
});
