/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.strategy.CatalogCategoryLoadAheadStrategy");

dojo.require("com.ibm.mashups.enabler.strategy.Strategy");
dojo.require("com.ibm.mashups.enabler.catalog.Factory");

/**
 * Interface that defines a load ahead mulipart strategy for loading the Catalog
 * Category Model as part of a multipart request
 * @ibm-api
 * @ibm-module CatalogModel
 */
dojo.declare("com.ibm.mashups.enabler.strategy.CatalogCategoryLoadAheadStrategy", com.ibm.mashups.enabler.strategy.Strategy, {
    /**
     * @param {boolean} loadAheadCatalogCategoryModel if the catalog
     * category model should be preloaded. Must not be <code>null</code>.
     */
    constructor: function(loadAheadCatalogCategoryModel){
        this.loadAheadCatalogCategoryModel = loadAheadCatalogCategoryModel;
        
        // temporary
        this.catalogCategoryModel = null;
    },
    
    /**
     * Returns if the catalog category model should be loaded
     * @return {Boolean} <code>true</code> if the catalog category model should
     *                   be preloaded, <code>false</code> otherwise
     */
    isLoadAheadCatalogCategoryModel: function(){
        return this.loadAheadCatalogCategoryModel;
    },
    
    // temporary
    setCatalogCategoryModel: function(catalogCategoryModel){
        this.catalogCategoryModel = catalogCategoryModel || null;
    },
    
    getCatalogCategoryModel: function(){
        if (null === this.catalogCategoryModel) {
            this.catalogCategoryModel = com.ibm.mashups.enabler.catalog.Factory.getCatalogCategoryModel();
        }
        return this.catalogCategoryModel;
    }
});
