/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.strategy.PrimingDataReplacementStrategy");

dojo.require("com.ibm.mashups.enabler.strategy.Strategy");

/**
 * Interface that defines a strategy for replacing otherwise primed artifacts of
 * a tree model after priming is stopped, which usually occurs when unprimed data
 * is fetched from the model or data is set to the model or its artifacts.<br>
 * This strategy defines the number of levels from the root element to load.
 * @ibm-spi
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.strategy.PrimingDataReplacementStrategy", com.ibm.mashups.enabler.strategy.Strategy, {
    /**
     * @param {int} parentLevel number of parent levels to be loaded ahead from
     * the backend. must not be <code>null</code> or less than one.
     * @param {int} childrenLevel number of children levels to be loaded ahead
     * from the backend. must not be <code>null</code> or less than one.
     */
    constructor: function(level) {
        this.level = level;
    },
    
    /**
     * Returns the number of levels in the hierarchy to load ahead
     * @return {int} number of levels to load ahead
     */
    getLevel: function() {
        return this.level;
    }
});
