/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.theme.Theme");

dojo.require("com.ibm.mashups.enabler.Identifiable");
dojo.require("com.ibm.mashups.enabler.Localized");
dojo.require("com.ibm.mashups.enabler.MetaData");

/**
 * Interface that represents a theme; used in the ThemeModel
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.theme.Theme", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.Localized, com.ibm.mashups.enabler.MetaData], {
    /**
     * Returns the base url of the theme.
     * @type String
     * @return base url of the theme. can never be <code>null</code>
     * @deprecated Since 2.0. Use ThemeModel/ResourceLocator findResourceURL instead
     */
    getBaseUrl: function(){
    },
    
    /**
     * Returns the default skin id for the given theme.
     * @type String
     * @return the default skin id for given theme, <code>null</code> in case of no default skin set.
     * @deprecated use com.ibm.mashups.enabler.ThemeProvider.getDefaultSkinIdentifier instead
     */
    getDefaultSkin: function(){
    },
    
    /**
     * Returns the default skin identifier for this theme.
     * @return {com.ibm.mashups.enabler.Identifiable} the default skin id for this theme, <code>null</code> in case of
     * no default skin set.
     */
    getDefaultSkinIdentifier: function(){
    }
    
});
