/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.utils.EventTransformer");

//<INTERFACE>
/**
 * Event Transformer that checks compatibility between events.
 * Compatibility checks work bi-directionally, for example a source event with payload type time can
 * be checked against a target event with payload xsd:time. The reverse direction can also be checked, i.e
 * a source event with xsd:time checked against a target event with payload time. The compatibility check is 
 * applicable for xsd primitive data types and Mashup simple types.
 *
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.utils.EventTransformer", null, {
    /**
     * Checks the compatibility of sourceEvent and  targetEvent.
     * 
     * @ibm-api
     *
     * @param {com.ibm.mashups.iwidget.event} sourceEvent the event to be checked
     * @param {com.ibm.mashups.iwidget.event} targetEvent the event that sourceEvent is checked against.
     * @param {Boolean} relaxed If relaxed is true, then the checking of the type matches are flexible,
     * if false then only direct type matches are checked
     * @return {Boolean} true if events are compatible, false otherwise.
     */
    isTransformable: function(sourceEvent, targetEvent, relaxed){
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.utils.EventTransformerImpl");
