/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.widget.EventProvider");

dojo.require("com.ibm.mashups.enabler.widget.Event");

/**
 * Interface for a widget event provider.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.EventProvider", null, {
    /**
     * Returns an array of wigdet events, never <code>null</code>.
     * @param {JSON} filter filter to limit the result to handled or published events; optional, must not 
     * be <code>null</code>. Accepted names are:<br>
     * &nbsp;&nbsp;<b><code>FILTER_HANDLED_EVENTS</code></b>, as defined in &nbsp; {@link com.ibm.mashups.enabler.widget.Constants Constants}; must 
     * be <code>true</code> to have handled events returned.<br>
     * &nbsp;&nbsp;<b><code>FILTER_PUBLISHED_EVENTS</code></b>, as defined in &nbsp; {@link com.ibm.mashups.enabler.widget.Constants Constants}; must be <code>true</code> to 
     * have published events returned.<br>
     * If no filter is set, both handled and published events are returned.<br>
     * <br>
     * For example, use the following code to get only the handled events:<br>
     * <code>getEvents({com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS: true});</code><br>
     * <br>
     * <b>Note:</b> Modifying the array does not change the widget events. 
     *
     * @return {Event[]} widget events
     */
    getEvents: function(filter){
    },
    
    /**
     * Returns the event identified by <tt>name</tt> or <tt>null</tt> if the event doesn't exist
     * in this provider.
     * @param {String} name the name of the&nbsp; {@link Event Event}.
     * @return {com.ibm.mashups.enabler.widget.Event} the event identified by <tt>name</tt> or <tt>null</tt>.
     */
    getEvent: function(name) {
        
    },

    /**
     * Returns the event identified by <tt>id</tt> or <tt>null</tt> if the event doesn't exist
     * in this provider.
     * @param {Identifiable} id identifiable or string id of the &nbsp; {@link Event Event}.
     * @return {com.ibm.mashups.enabler.widget.Event} the event or <tt>null</tt>.
     */
    getEventByID: function(id) {
        
    },

    /**
     * @private
     */
    HANDLED_NAME_PREFIX: "handled_",
    /**
     * @private
     */
    PUBLISHED_NAME_PREFIX: "published_"
});
