/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.wire.Wire");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.Identifiable");

/**
 * Interface for a wire.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.wire.Wire", [com.ibm.mashups.enabler.Identifiable], {

    /**
     * Returns the identifier of the source widget associated with this wire
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the widget instance identifier
     */
    getSourceWidget: function(){
    },
    
    /**
     * Returns the identifier of the source event associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the source event
     */
    getSourceEvent: function(){
    },
	
    /**
     * Returns the name of the source event associated with this wire.
     *
     * @return {String} the event name
     */
    getSourceEventName: function(){
    },
    
    /**
     * Returns the identifier of the source page associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the page identifier
     */
    getSourcePage: function(){
    },
    
    /**
     * Returns the identifier of the target widget associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the widget instance identifier
     */
    getTargetWidget: function(){
    },
    
    /**
     * Returns the identifier of the target event associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the target event
     */
    getTargetEvent: function(){
    },
	
    /**
     * Returns the name of the target event associated with this wire.
     *
     * @return {String} the event name
     */
    getTargetEventName: function(){
    },
    
    /**
     * Returns the identifier of the target page associated with this wire.
     *
     * @return {com.ibm.mashups.enabler.Identifiable} the page identifier
     */
    getTargetPage: function(){
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.wire.WireImpl");
