/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.itemset.ShareableItemSet");


/**
 * Interface to a simple abstraction of a datamodel which is shared across different components.
 * @ibm-api
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.itemset.ShareableItemSet", null, {
    /**
     @private
     */
    constructor: function() {
    },
    /**
     This method sets an item within the ShareableItemSet, creates or replaces an existing entry as needed.
     To add an additional value to any existing item, suggest to get the current value of this item and append
     the new value to the list and supply the result to this method.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @param{String}value value of the item. Must never be <code>null</code>.
     @return{com.ibm.mashups.iwidget.itemset.ShareableItemSet} return an handle of ShareableItemSet upon successful, <code>null</code> upon failure.
     */
    setItemValue: function( /*String*/itemName, /*String*/ value) {
        return this;
    },
    /**
     This method returns the value for the named item from the set.
     @param{String}itemName name of the item. Must never be <code>null</code>.
     @return{String} return the named item for the set, <code>null</code> upon failure.
     */
    getItemValue: function( /*String*/itemName) {
        return null;
    },
    /**
     This method returns an array of Strings, providing the name of each item.
     @return{String[]}  return an array of items names and return <code>null</code> if the set contains no item
     */
    getAllNames: function() {
        return null;
    },
    /**
     Removes the named item from the set.
     @param{String}itemName name of the item that needs to be removed. Must never be <code>null</code>.
     @return{com.ibm.mashups.iwidget.itemset.ShareableItemSet} return the handle to the ShareableItemSet upon successful, <code>null</code> upon failure.
     */
    removeItem: function(/*String*/itemName) {
        return null;
    },
    /**
     This funtions commits all the changes that's applied to ShareableItemSet. Any udpates should be distributed to client side  components that has registered listener on this ShareableItemSet.
     @type void
     */
    commit: function() {
        return null;
    },
    /**
     This function adds listener to this ShareableItemSet. So it will gets notified when this ShareableItemSet is updated.
     @param{Function}listener js function that should already be properly scoped. Must never be <code>null</code>.
     @return{String} return listener id if listener is registered successfully, return null if it's not.
     */
    addListener: function(/*Function*/listener) {
        return null;
    },
    /**
     This function removes the  listener from this ShareableItemSet.
     @param{String}listenerId  listener id that's returned by the system when listener is added. Must never be <code>null</code>.
     @return{Boolean} return true if listener is removed successfully.
     */
    removeListener: function(/*String*/listenerId) {
        return true;
    } //return true if listener is removed successfully
});




