/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.services.WidgetEventModelFactoryService");

//<INTERFACE>
/**
 * @private
 * @ibm-module iWidget
 */
dojo.declare("com.ibm.mashups.iwidget.services.WidgetEventModelFactoryService",null,  {
    /**
     * Creates event model for the specified widget by honoring the current persistence mode (e.g. DOM vs. Model).
     * The factory for the current persistence mode needs to be added to this service by using the <tt>addFactory</tt> method of this class.
     * 
     * @param {com.ibm.mashups.iwidget.widget.IWidgetWrapper} widget the widget for which to create the event model
     * @param {String} persistence Mode 
     * @return {com.ibm.mashups.iwidget.model.EventModel} an event model for the specified widget using the according factory or <tt>null</tt> if no factory is available for the current mode.
     */
    createEventModel: function(widgetWrapper,persistenceMode) {
        
    },
    /**
     * Sets the factory for the specified persistenceMode to this service.
     * @param {String} persistenceMode the mode that is supported by the specified factory
     * @param {com.ibm.mashups.iwidget.services.WidgetEventModelFactory} factory the factory that creates the attributes.
     * @return {void}
     */
    setFactory: function(persistenceMode, factory) {
        
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.iwidget.services.WidgetEventModelFactoryServiceImpl");
