/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetDefinition");

dojo.require("com.ibm.mashups.iwidget.widget.EventProvider");
dojo.require("com.ibm.mashups.iwidget.widget.PropertiesProvider");
//<INTERFACE>
/**
 * Interface defines functions to access all the data object in widget definition. PropertiesProvider is not implemented.
 * @ibm-spi
 * @ibm-module iWidget2
  */
dojo.declare("com.ibm.mashups.iwidget.widget.IWidgetDefinition",[com.ibm.mashups.iwidget.widget.EventProvider,com.ibm.mashups.iwidget.widget.PropertiesProvider],{
  	/**
            * @private
            */	
    constructor:function(){
 
	},
/**
This method returns an array of supported modes such as "view" and "edit".
@returns{String[] }  array of supported modes this iWidget supports.
*/				  
    getSupportedModes:function(){
    },    

/**
This method returns a  JSON based spec compliant object that represents all the data that's defined in widget xml.<p/>
Rule to follow:<br/>
1. Element -- "iw:iwidget" is considered to be root Element and a root object is created from here.<p/>
2. Any  attribute of this element will be a field in the root object. '_' will be added as prefix to field names.<br/>
   ":" within any namespaced attribute will be replaced with "_". 
<code>&lt;iw:iwidget id="map" xml:base="/root/test/" allowInstanceContent="false"......&gt;</code><br/>
{ _id:"map",_xml_base:"/root/test/",_allowInstanceContent:"false"......}<p/>
3. All repreatable elements, element name (append with "s") is used as a field name and an object is created to contain all the repeatable elements.
Within that object, value of "id" attribute is used as field name for an individual element if id attribute is available.<br/>
{<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;resources:{<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"myId":{_id:"myId",_src:"my.js"},<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		"myOtherId":{_id:"myOtherId",_src:"my2.js"}<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		}<br/>
}<p/>
4. For "iw:content" elements, "contents" is used as the key in the parent object and an object is created to contain all the content elements.<br/>
For each "content" element, "mode" attribute is used  as the key and CDATA section is saved as the value.<br/>
{<br/>
&nbsp;&nbsp;&nbsp;contents:{<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "view": {<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "_mode": "view",<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "value": "mycontent"<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br/>
&nbsp;&nbsp;&nbsp; }<br/>	 
}<p/>
5. For "iw:alt" elements,"alts" is used as the key in parent object and an object is created to contain all the alt elements.<br/>
For each "alt" element, "lang" attribute is used  as the key and  all the attributes are saved per attributes convention.<br/>
eventDescname:{<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;_id:"eventDescnname",<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;_payloadType:"payloadType",<br/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;alts:{<br/>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"en":{_lang:'en',_description:"description",_descriptionURI:"descriptionURI"},<br/>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"zh":{_lang:'zh',_description:"description",_descriptionURI:"descriptionURI"}<br/>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;}<br/>
}<p/>
An example of simple iWidget and  the return result.<br/>
<code>&lt;iw:iwidget id="stock" xmlns:iw="http://www.ibm.com/xmlns/prod/iWidget" iScope="stock" allowInstanceContent="true" supportedModes="view edit " mode="view" lang="en"></code><br/>
&nbsp;&nbsp;&nbsp;<code> &lt;iw:itemSet id="attributes" private="true" onItemSetChanged="changeItemSet"&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;iw:item id="broker"  readOnly="false"    value="Etrade" /&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code> &lt;iw:item id="company"  value="IBM" /&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;<code>&lt;/iw:itemSet&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;<code> &lt;iw:event id="sendStockData" eventDescName="sendStockDataDesc"  published="true" onNewWire="sendData" /&gt; </code><br/> 
 &nbsp;&nbsp;&nbsp;<code> &lt;iw:eventDescription  id="sendStockDataDesc"  payloadType="stockData" title="Send stock data"  lang="en"  &gt;</code><br/>
   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<code>&lt;iw:alt title="Send stock data"  lang="en" /&gt; </code><br/>
  &nbsp;&nbsp;&nbsp;<code>&lt;/iw:eventDescription&gt;</code><br/>
 &nbsp;&nbsp;&nbsp;<code>&lt;iw:resource src="stock.js" id="stock" /&gt;</code><br/>
  &nbsp;&nbsp;&nbsp;<code>&lt;iw:content mode="view"&gt;
        &lt;![CDATA[    
          mycontent
            ]]&gt;
     &lt;/iw:content&gt;</code><br/> 
  &nbsp;&nbsp;&nbsp;<code>&lt;/iw:iwidget&gt;</code><p/>
  
  Example of returnin json object. <br/>
  <code>
  {  _id:"map",_allowInstanceContent:"true",_iScope:"stock",_supportedModes:"view edit",_mode:"view",_lang:"en",<br/>
      &nbsp;&nbsp;&nbsp; itemSets:{<br/>
	       &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"attributes":{  _id:"attributes", _private:"true",_onItemSetChanged:"changedItemSet",<br/>
	        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;                  items:{ <br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  			"broker":{  _id:"broker",_readOnly:"false", _value:"Etrade"},<br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  			"company":{ _id:"company",_value;"IBM"} <br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		     }<br/>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;	            }<br/>
     &nbsp;&nbsp;&nbsp;},<br/>
           &nbsp;&nbsp;&nbsp;events:{ <br/>
	        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"sendStockData":{  _id:"sendStockData", _eventDescName:"sendStockDataDesc", _published:"true",_onNewWire:"sendData"}<br/>
	 &nbsp;&nbsp;&nbsp;},<br/>
           &nbsp;&nbsp;&nbsp;eventDescriptions:{<br/>
	        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"sendStockDataDesc":{ _id:"sendStockDataDesc", _payloadType:"stockData",_title:"Send stock data",_lang:"en",<br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  	                    alts:{<br/>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp;  			        "en":{ _lang:"en",_title:"Send stock data"}	<br/>		
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  			      }	<br/>	
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			}<br/>	  
	&nbsp;&nbsp;&nbsp;		    },<br/>
         &nbsp;&nbsp;&nbsp; resources:{<br/>	
		       &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"stock":{ _id:"stock", _src:"stock.js"}<br/>
	&nbsp;&nbsp;&nbsp;},<br/>
           &nbsp;&nbsp;&nbsp;contents:{<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "view": {<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "_mode": "view",<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; "value": "mycontent"<br/>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; }<br/>
    &nbsp;&nbsp;&nbsp; }<br/>	 
  }<br/>
  </code>

@returns{object} a JSON based, spec compliant object that represents all the data that's defined in widget.xml
*/
    toSpecObject:function(){
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.iwidget.widget.IWidgetDefinitionDefaultImpl");
