/* Copyright IBM Corp. 2010  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.widget.IWidgetWrapper");

dojo.require("com.ibm.mashups.enabler.Deferred");
dojo.require("com.ibm.mashups.iwidget.widget.WireProvider");
dojo.require("com.ibm.mashups.iwidget.widget.EventProvider");
dojo.require("com.ibm.mashups.iwidget.widget.IWidgetDefinition");
dojo.require("com.ibm.mashups.iwidget.widget.IWidgetInstance");
//<INTERFACE>
/**
 * IWidgetWrapper interface  represents a runtime instance of an iWidget on the page. Information provided by the IWidgetWrapper is an aggregation of definition level data and instance level data.
 * To get desriptive data that's specific to instance level and definition level. It should use Provider api that's implemented by IWidgetDefinition or IWidgetIstance.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.IWidgetWrapper", [com.ibm.mashups.iwidget.widget.WireProvider, com.ibm.mashups.iwidget.widget.EventProvider], {
    /**
     * @private
     */
    constructor: function() {
    
    },
    
    /**
     This method returns iWidgetDefinition of  this runtime instance.<br/>
     <code>var deferred = widgetWrapper.getIWidgetDefinition();</code><br/>
     <code>deferred.setFinishedCallback(callback,parameters);</code><br/>
     <code>deferred.start(true);</code><br/>
     here are the callback parameters that will be passed into callback function: <br/>
     &nbsp;&nbsp;&nbsp;&nbsp;<code>resource</code> -  IWidgetDefinition object <br>
     &nbsp;&nbsp;&nbsp;&nbsp;<code>statusCode</code> - the overall HTTP status,code of the action (the highest status code of the involved operations).<br>
     &nbsp;&nbsp;&nbsp;&nbsp;<code>params</code> - the parameters passed into the callback <br>
     @type com.ibm.mashups.enabler.Deferred
     @returns{com.ibm.mashups.enabler.Deferred}  a deferred object used to start this operation.
     @see com.ibm.mashups.iwidget.widget.IWidgetDefinition
     */
    getIWidgetDefinition: function() {
    },
    
    /**
     Sets the iWidgetDefinition for this runtime instance
     @param{com.ibm.mashups.iwidget.widget.IWidgetDefinition} widgetDefinition IWidgetDefinition to use for this runtime instance. Must not be null.
     @type{void}
     @return{void}
     */
    setIWidgetDefinition: function(widgetDefinition) {
    },
    /**
     This method returns iWidgetInstance which contains all the descriptive data for this iWidget instance
     @type com.ibm.mashups.iwidget.widget.IWidgetInstance
     @returns{com.ibm.mashups.iwidget.widget.IWidgetInstance }  iWidgetInstance object
     */
    getIWidgetInstance: function() {
    },
    /**
     * This method returns the a clone of the content of the widget as it is inside of the DOM.<br/>It removes automatically
     * any markup that was added to the DOM using microformats (given that the microformat implements the unProcess handler).<br/>
     * This method does not remove any additional DOM changes that where done by the widget itself and applies the unProcess only<br/>
     * to the subnodes of the actual widget node.<br/><br/>
     * If your widget needs to take special action to it's DOM nodes before the getMarkup is processing it, you can define the method<br/>
     * <code>_onGetMarkup</code> in your widgets JavaScript file. This method, as part of the iScope, will always be called before the actual<br/>
     * markup is processed.<br/><br/>
     * <b>The synchrounus mode of returned Deferred is not supported.</b>
     * @type com.ibm.mashups.enabler.Deferred
     * @returns {com.ibm.mashups.enabler.Deferred} a deferred object used to fetch the actual markup.
     */
    getMarkup: function() {
    },
    /**
     This method returns  true if an iwidget instance is already loaded on the page dom.
     @type Boolean
     @returns{Boolean }  true if widget is already completely rendered on the page.
     */
    isLoaded: function() {
    },
    /**
     * This method returns  true if an iwidget instance is standalone on the page.
     * @type Boolean
     * @returns{Boolean}  true if widget is standalone on the page.
     */
    isStandalone: function() {
    },
  /**
     This method displays the widgets on the page if widget has not been displayed yet.
     @type void
     */
    doRender: function() {
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.iwidget.widget.IWidgetWrapperDefaultImpl");
